; ====================================
;
;
;       Playing sounds by using DirectSound
;
;
; ====================================

; 

        InitDSound      PROTO :DWORD,:DWORD,:DWORD,:DWORD
        CloseDSound     PROTO
        StartDSound     PROTO
        StopDSound      PROTO
        CopyDSound      PROTO :DWORD,:DWORD,:DWORD
        MixIntoDSBuffer PROTO :DWORD,:DWORD,:DWORD

; 

 .data?
 align 4
    lpDS            LPDIRECTSOUND8       ?
    lpDSSample      LPDIRECTSOUNDBUFFER8 ?
    lpIDSNotify     LPDIRECTSOUNDNOTIFY8 ?
    PositionNotify  DSBPOSITIONNOTIFY 2 dup (<>)
    dsbdesc         DSBUFFERDESC <>
    wfx             WAVEFORMATEX <>
    DSBufferHalf    dd ?

    SampleBuffer    BUFFER <>

; MixingThread
    MixThreadID     dd ?
    hMixThread      dd ?
    isTerminating   dd ?

    sData           dd ?
    sLength         dd ?
    Notifications   label DWORD
    hNotification1  dd ?
    hNotification2  dd ?
    hNotification3  dd ?

 .data
    DS_M_INIT           dd 0
                        db 'DirectSound initialized.',0Dh,0Ah,0
    DS_M_CREATE_I8      dd 1
                        db 'DirectSoundCreate',0
    DS_M_COOPERATIVE    dd 2
                        db 'SetCooperativeLevel',0
    DS_M_CREATE_BUF     dd 3
                        db 'CreateSoundBuffer',0
    DS_M_LOCK_BUF       dd 4
                        db 'LockSoundBuffer',0
    DS_M_UNLOCK_BUF     dd 5
                        db 'UnlockSoundBuffer',0
    DS_M_SET_FORMAT     dd 6
                        db 'SetPrimaryFormat',0
    DS_M_NOTIFY         dd 7
                        db 'SetNotification',0
    DS_M_THREAD         dd 8
                        db 'Create Play Thread',0

    DS_guid_data      GUID DS3DALG_DEFAULT

    IID_IDSNotify     GUID IID_IDirectSoundNotify
; 

 .code
align 4

; 
;
;
;
; 
MixThreadProc       PROC lParam:DWORD

@_PlayThreadLoop:
PrintText '--mix--------'
                        invoke WaitForMultipleObjects,3,addr Notifications,FALSE,INFINITE
PrintHex al,'signalled object'
                        .if (eax == WAIT_FAILED)
                            jmp @_MixThread_Stop
                        .elseif (eax == 0)
; first half of buffer played
                            invoke MixIntoDSBuffer,addr SampleBuffer,0,DSBufferHalf
                        .elseif (eax == 1)
; second half of buffer played
                            invoke MixIntoDSBuffer,addr SampleBuffer,DSBufferHalf,DSBufferHalf
                        .elseif (eax == 2)
; stop request received
@_MixThread_Stop:
                            coinvoke lpDSSample,IDirectSoundBuffer8,SetCurrentPosition,0
                            coinvoke lpDSSample,IDirectSoundBuffer8,Stop
                            invoke CloseDSound
                            ;invoke SetEvent,hNotification4
                            invoke  ExitThread,NULL
                        .else
                        .endif

                    jmp @_PlayThreadLoop

MixThreadProc      ENDP

; 
;
;
;
; 

MixIntoDSBuffer PROC USES ebx esi lpBuffer:DWORD,dwOffset:DWORD,dwLength:DWORD

                mov     esi,lpBuffer
                ASSUME esi:PTR BUFFER
                mov     eax,[esi].CURR_         ; BufferPtr
                mov     ebx,eax
                add     eax,dwLength
                cmp     eax,[esi].END_          ; BufferEnd
                jc  @_Mix1
                jnz  @_Mix2
; -------------------------------------------------------------------------
; DSBuffer is filled in one run from sampleBuffer
;   sampleBuffer.CURR_ + dwLength = sampleBuffer.END_
; -------------------------------------------------------------------------
                mov     ebx,[esi].START_
;PrintText 'restart'
; -------------------------------------------------------------------------
; DSBuffer is filled in one run from sampleBuffer
;   sampleBuffer.CURR_ + dwLength < sampleBuffer.END_
; -------------------------------------------------------------------------
@_Mix1:
;PrintHex ebx,'current'
                invoke CopyDSound,ebx,dwOffset,dwLength
                add     ebx,dwLength
;PrintHex ebx,'current'
                mov     [esi].CURR_,ebx
                ret

; -------------------------------------------------------------------------
; DSBuffer is filled in one run from sampleBuffer
; sampleBuffer.CURR_ + dwLength > sampleBuffer.END_
; -------------------------------------------------------------------------
@_Mix2:
                mov     eax,[esi].END_
                sub     eax,ebx
                push    eax
                push    eax             ; Length1 = Buffer.END_ - Buffer.CURR_
;PrintHex eax,'Length1'
                push    dwOffset
                push    [esi].CURR_
                call CopyDSound

                mov     eax,dwLength
                pop     ebx
                sub     eax,ebx         ; Length2 = dwLength - Length1
                push    eax
;PrintHex eax,'Length2'
                push    eax
                add     ebx,dwOffset    ; Offset = dwOffset + Length1
                push    ebx
                push    [esi].START_
                call CopyDSound
                pop     eax
                add     eax,[esi].START_
                mov     [esi].CURR_,eax

                ret

MixIntoDSBuffer ENDP
; 
;
;
;
; 
InitDSound     PROC USES ebx ecx edx esi edi hWnd:DWORD,sampleRate:DWORD,nChannels:DWORD,sampleBits:DWORD

LOCAL		lpDSBPrimary:LPDIRECTSOUNDBUFFER8

LOCAL       BlockAlign:DWORD
LOCAL       AvgBytesPerSec:DWORD

; ----------------
; Create DS Object
    
                invoke DirectSoundCreate,NULL,addr lpDS,NULL
                .if (eax != DS_OK)
                    lea     eax,DS_M_CREATE_I8
                    jmp @_InitDS_END
                .endif
                coinvoke lpDS,IDirectSound8,SetCooperativeLevel,hWnd,DSSCL_PRIORITY 
                .if (eax != DS_OK)
                    lea     eax,DS_M_COOPERATIVE
                    jmp @_InitDS_END
                .endif
; ----------------
; adjust primary buffer format
                mov     ecx,sizeof dsbdesc-1
                lea     esi,dsbdesc
                xor     al,al
@_InitDS_10:
                mov     [esi+ecx],al
                sub     ecx,1
                jnc @_InitDS_10

                mov     dsbdesc.dwSize,sizeof DSBUFFERDESC
                mov     dsbdesc.dwFlags,DSBCAPS_PRIMARYBUFFER
                coinvoke lpDS,IDirectSound8,CreateSoundBuffer,addr dsbdesc,addr lpDSBPrimary,NULL 
                .if (eax != DS_OK)
                    lea     eax,DS_M_SET_FORMAT
                    jmp @_InitDS_END
                .endif

                mov     ecx,sizeof wfx-1
                lea     esi,wfx
                xor     al,al
@_InitDS_11:
                mov     [esi+ecx],al
                sub     ecx,1
                jnc @_InitDS_11

                mov     wfx.wFormatTag,WAVE_FORMAT_PCM
                m2m     wfx.nChannels,nChannels
                m2m     wfx.nSamplesPerSec,sampleRate
                mov     eax,sampleBits
                mov     wfx.wBitsPerSample,ax
                shr     eax,3
                mul     nChannels
                mov     wfx.nBlockAlign,ax              ; nChannels*wBitsPerSample/8
                mov     BlockAlign,eax
;PrintDec eax,'nBlockAlign'
                mul     sampleRate
                mov     wfx.nAvgBytesPerSec,eax         ; nSamplesPerSec*nBlockAlign
                mov     AvgBytesPerSec,eax
;PrintDec eax,'nAvgBytesPerSec'
                coinvoke lpDSBPrimary,IDirectSoundBuffer8,SetFormat,addr wfx
                .if (eax != DS_OK)
                    lea     eax,DS_M_SET_FORMAT
                    jmp @_InitDS_END
                .endif

                SAFE_RELEASE lpDSBPrimary

; ----------------
; Init a DirectSound buffer
                mov     ecx,sizeof wfx-1
                lea     esi,wfx
                xor     al,al
@_InitDS_12:
                mov     [esi+ecx],al
                sub     ecx,1
                jnc @_InitDS_12

                mov     ecx,sizeof dsbdesc-1
                lea     esi,dsbdesc
                xor     al,al
@_InitDS_13:
                mov     [esi+ecx],al
                sub     ecx,1
                jnc @_InitDS_13
    
                mov     dsbdesc.dwSize,sizeof DSBUFFERDESC
                mov     dsbdesc.dwFlags,DSBCAPS_GLOBALFOCUS or DSBCAPS_CTRLPOSITIONNOTIFY
                mov     eax,AvgBytesPerSec
                mov     dsbdesc.dwBufferBytes,eax
                shr     eax,1
                mov     DSBufferHalf,eax
;PrintDec eax,'DSBufferHalf'
    
                mov     wfx.wFormatTag,WAVE_FORMAT_PCM
                m2m     wfx.nChannels,nChannels
                m2m     wfx.nSamplesPerSec,sampleRate
                mov     eax,sampleBits
                mov     wfx.wBitsPerSample,ax
                mov     eax,BlockAlign
                mov     wfx.nBlockAlign,ax              ; nChannels*wBitsPerSample/8
                m2m     wfx.nAvgBytesPerSec,dsbdesc.dwBufferBytes
;PrintDec eax,'nAvgBytesPerSec'
                mov     wfx.cbSize,0                    ; no extra format data
                lea     eax,wfx
                mov     dsbdesc.lpwfxFormat,eax
    
                lea     ebx,dsbdesc.guid3DAlgorithm
                mov     eax,DWORD PTR [DS_guid_data]
                mov     [ebx],eax
                mov     eax,DWORD PTR [DS_guid_data+04h]
                mov     [ebx+04h],eax
                mov     eax,DWORD PTR [DS_guid_data+08h]
                mov     [ebx+08h],eax
                mov     eax,DWORD PTR [DS_guid_data+0Ch]
                mov     [ebx+0Ch],eax

; ----------------
; create the soundbuffer
                coinvoke lpDS,IDirectSound8,CreateSoundBuffer,addr dsbdesc,addr lpDSSample,NULL 
                .if (eax != DS_OK)
                    lea     eax,DS_M_CREATE_BUF
                    jmp @_InitDS_END
                .endif

; ----------------
; set up notification
                invoke CreateEvent,NULL,FALSE,FALSE,NULL    ; event for 1st half played
                .if (eax == NULL)
                    lea     eax,DS_M_NOTIFY
                    jmp @_InitDS_END
                .endif
                mov     [hNotification1],eax

                invoke CreateEvent,NULL,FALSE,FALSE,NULL    ; event for 2nd half played

                .if (eax == NULL)
                    lea     eax,DS_M_NOTIFY
                    jmp @_InitDS_END
                .endif
                mov     [hNotification2],eax

                invoke CreateEvent,NULL,FALSE,FALSE,NULL    ; event for stop mixing
                .if (eax == NULL)
                    lea     eax,DS_M_NOTIFY
                    jmp @_InitDS_END
                .endif
                mov     [hNotification3],eax

comment %
                invoke CreateEvent,NULL,FALSE,FALSE,NULL    ; event for mixing stopped
                .if (eax == NULL)
                    lea     eax,DS_M_NOTIFY
                    jmp @_InitDS_END
                .endif
                mov     [hNotification4],eax
                invoke ResetEvent,eax
%
                coinvoke lpDSSample,IDirectSoundBuffer8,QueryInterface,addr IID_IDSNotify,addr lpIDSNotify
                .if (eax != DS_OK)
                    lea     eax,DS_M_NOTIFY
                    jmp @_InitDS_END
                .endif

                mov     eax,dsbdesc.dwBufferBytes
                sub     eax,1

                lea     esi,PositionNotify
                ASSUME esi:PTR DSBPOSITIONNOTIFY
                    mov     [esi].dwOffset,eax                  ; notification at the end
                    mov     ebx,[hNotification2]
                    mov     [esi].hEventNotify,ebx
                add     esi,sizeof DSBPOSITIONNOTIFY
                shr     eax,1
                    mov     [esi].dwOffset,eax                  ; notification at the half
                    mov     ebx,[hNotification1]
                    mov     [esi].hEventNotify,ebx
                coinvoke lpIDSNotify,IDirectSoundNotify,SetNotificationPositions,2,addr PositionNotify
                ASSUME esi:NOTHING
                .if (eax != DS_OK)
                    lea     eax,DS_M_NOTIFY
                    jmp @_InitDS_END
                .endif

                SAFE_RELEASE lpIDSNotify
; ----------------
; set up mixing thread
                invoke CreateThread,NULL,0,addr MixThreadProc,NULL,CREATE_SUSPENDED,addr MixThreadID
                .if (eax == NULL)
                    lea     eax,DS_M_THREAD
                    jmp @_InitDS_END
                .endif
                mov     hMixThread,eax

                ; invoke MixIntoDSBuffer,addr SampleBuffer,0,DSBufferHalf

                lea     eax,DS_M_INIT
@_InitDS_END:
                ret
InitDSound      ENDP

; 
;
;
;
; 
CopyDSound     PROC USES ebx ecx esi edi lpSamples:DWORD,dwOffset:DWORD,dwLength:DWORD


; ----------------
; lock the soundbuffer
                coinvoke lpDSSample,IDirectSoundBuffer8,Lock,0,dwLength,addr sData,addr sLength,NULL,0,0
                .if (eax != DS_OK)
                    .if (eax == DSERR_BUFFERLOST)
                        coinvoke lpDSSample,IDirectSoundBuffer8,Restore
                        .if (eax == DS_OK)
                            jmp @_CopyDS_0
                        .endif
                     .endif
                    lea     eax,DS_M_LOCK_BUF
                    jmp @_CopyDS_END
                .endif
@_CopyDS_0:
; ----------------
; copy the wave data into the soundbuffer
                mov     ecx,sLength
                mov     esi,sData
PrintHex esi,'DSBuffer address'
                add     esi,dwOffset
                mov     edi,lpSamples
PrintHex edi,'SampleBuffer current'
push    edi
sub     edi,[SampleBuffer].START_
PrintDec edi,'SampleBuffer offset'
mov     edi,[SampleBuffer].END_
PrintHex edi,'SampleBuffer end'
pop     edi
@_CopyDS_1:
                mov     eax,[edi+ecx]
                mov     [esi+ecx],eax
                sub     ecx,4
                jnc @_CopyDS_1
; ----------------
; unlock the soundbuffer
                coinvoke lpDSSample,IDirectSoundBuffer8,Unlock,sData,sLength,NULL,0
                .if (eax != DS_OK)
                    lea     eax,DS_M_UNLOCK_BUF
                    jmp @_CopyDS_END
                .endif

                lea     eax,DS_M_INIT
@_CopyDS_END:

                ret
CopyDSound     ENDP

; 

StartDSound     PROC

                coinvoke lpDSSample,IDirectSoundBuffer8,SetCurrentPosition,0 
                coinvoke lpDSSample,IDirectSoundBuffer8,Play,0,0,DSBPLAY_LOOPING
                invoke ResumeThread,hMixThread

                ret

StartDSound     ENDP

; 

StopDSound      PROC

                coinvoke lpDSSample,IDirectSoundBuffer8,Stop
                
                ret

StopDSound      ENDP

; 

CloseDSound     PROC

                invoke StopDSound
                SAFE_RELEASE lpDSSample
                SAFE_RELEASE lpDS

                ret

CloseDSound     ENDP